# Class DefaultEnvironmentalRecord

Object
AbstractMetadata
ModifiableMetadata
ISOMetadata
DefaultEnvironmentalRecord

All Implemented Interfaces:
  `Serializable`, `Emptiable`, `LenientComparable`, `IdentifiedObject`, `EnvironmentalRecord`

public class DefaultEnvironmentalRecord extends ISOMetadata implements EnvironmentalRecord
Information about the environmental conditions during the acquisition. The following properties are mandatory in a well-formed metadata according ISO 19115:
`MI_EnvironmentalRecord` `├─averageAirTemperature……………` Average air temperature along the flight pass during the photo flight. `├─maxRelativeHumidity…………………` Maximum relative humidity along the flight pass during the photo flight. `├─maxAltitude………………………………………` Maximum altitude during the photo flight. `└─meteorologicalConditions……` Meteorological conditions in the photo flight area, in particular clouds, snow and wind.

## Limitations

- Instances of this class are not synchronized for multi-threading. Synchronization, if needed, is caller's responsibility.
- Serialized objects of this class are not guaranteed to be compatible with future Apache SIS releases. Serialization support is appropriate for short term storage or RMI between applications running the same version of Apache SIS. For long term storage, use `XML` instead.

Since:
  0.3
See Also:
  - Serialized Form

- ## Nested Class Summary

  ### Nested classes/interfaces inherited from class ModifiableMetadata

  `ModifiableMetadata​.State`

- ## Field Summary

  ### Fields inherited from class ISOMetadata

  `identifiers`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `DefaultEnvironmentalRecord()`
  Constructs an initially empty environmental record.
  `DefaultEnvironmentalRecord(EnvironmentalRecord object)`
  Constructs a new instance initialized with the values from the specified metadata object.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static DefaultEnvironmentalRecord`
  `castOrCopy(EnvironmentalRecord object)`
  Returns a SIS metadata implementation with the values of the given arbitrary implementation.
  `Double`
  `getAverageAirTemperature()`
  Returns the average air temperature along the flight pass during the photo flight.
  `Double`
  `getMaxAltitude()`
  Returns the maximum altitude during the photo flight.
  `Double`
  `getMaxRelativeHumidity()`
  Returns the maximum relative humidity along the flight pass during the photo flight.
  `InternationalString`
  `getMeteorologicalConditions()`
  Returns the meteorological conditions in the photo flight area, in particular clouds, snow and wind.
  `void`
  `setAverageAirTemperature(Double newValue)`
  Sets the average air temperature along the flight pass during the photo flight.
  `void`
  `setMaxAltitude(Double newValue)`
  Sets the maximum altitude value.
  `void`
  `setMaxRelativeHumidity(Double newValue)`
  Sets the maximum relative humidity along the flight pass during the photo flight.
  `void`
  `setMeteorologicalConditions(InternationalString newValue)`
  Sets the meteorological conditions in the photo flight area, in particular clouds, snow and wind.

  ### Methods inherited from class ISOMetadata

  `getIdentifier, getIdentifierMap, getIdentifiers, getStandard, setIdentifier`

  ### Methods inherited from class ModifiableMetadata

  `checkWritePermission, collectionType, copyCollection, copyList, copyMap, copySet, deepCopy, nonNullCollection, nonNullList, nonNullMap, nonNullSet, singleton, state, writeCollection, writeList, writeMap, writeSet`

  ### Methods inherited from class AbstractMetadata

  `asMap, asTreeTable, clone, equals, equals, getInterface, hashCode, isEmpty, nilReasons, prune, toString`

  ### Methods inherited from class Object

  `finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### DefaultEnvironmentalRecord

    public DefaultEnvironmentalRecord()
    Constructs an initially empty environmental record.

  - ### DefaultEnvironmentalRecord

    public DefaultEnvironmentalRecord(EnvironmentalRecord object)
    Constructs a new instance initialized with the values from the specified metadata object. This is a shallow copy constructor, because the other metadata contained in the given object are not recursively copied.

    #### Note on properties validation

    This constructor does not verify the property values of the given metadata (e.g. whether it contains unexpected negative values). This is because invalid metadata exist in practice, and verifying their validity in this copy constructor is often too late. Note that this is not the only hole, as invalid metadata instances can also be obtained by unmarshalling an invalid XML document.
    Parameters:
      `object` - the metadata to copy values from, or `null` if none.
    See Also:
      - `castOrCopy(EnvironmentalRecord)`

- ## Method Details

  - ### castOrCopy

    public static DefaultEnvironmentalRecord castOrCopy(EnvironmentalRecord object)
    Returns a SIS metadata implementation with the values of the given arbitrary implementation. This method performs the first applicable action in the following choices:
    - If the given object is `null`, then this method returns `null`.
    - Otherwise if the given object is already an instance of `DefaultEnvironmentalRecord`, then it is returned unchanged.
    - Otherwise a new `DefaultEnvironmentalRecord` instance is created using the copy constructor and returned. Note that this is a shallow copy operation, because the other metadata contained in the given object are not recursively copied.
    Parameters:
      `object` - the object to get as a SIS implementation, or `null` if none.
    Returns:
      a SIS implementation containing the values of the given object (may be the given object itself), or `null` if the argument was null.

  - ### getAverageAirTemperature

    public Double getAverageAirTemperature()
    Returns the average air temperature along the flight pass during the photo flight.
    Specified by:
      `getAverageAirTemperature` in interface `EnvironmentalRecord`
    Returns:
      average air temperature along the flight pass during the photo flight, or `null`.

  - ### setAverageAirTemperature

    public void setAverageAirTemperature(Double newValue)
    Sets the average air temperature along the flight pass during the photo flight.
    Parameters:
      `newValue` - the new average air temperature value.

  - ### getMaxRelativeHumidity

    @ValueRange(minimum=0.0, maximum=100.0) public Double getMaxRelativeHumidity()
    Returns the maximum relative humidity along the flight pass during the photo flight.
    Specified by:
      `getMaxRelativeHumidity` in interface `EnvironmentalRecord`
    Returns:
      maximum relative humidity along the flight pass during the photo flight, or `null`.

  - ### setMaxRelativeHumidity

    public void setMaxRelativeHumidity(Double newValue)
    Sets the maximum relative humidity along the flight pass during the photo flight.
    Parameters:
      `newValue` - the new maximum relative humidity, or `null`.
    Throws:
      `IllegalArgumentException` - if the given value is out of range.

  - ### getMaxAltitude

    public Double getMaxAltitude()
    Returns the maximum altitude during the photo flight.
    Specified by:
      `getMaxAltitude` in interface `EnvironmentalRecord`
    Returns:
      maximum altitude during the photo flight, or `null`.

  - ### setMaxAltitude

    public void setMaxAltitude(Double newValue)
    Sets the maximum altitude value.
    Parameters:
      `newValue` - the new maximum altitude value.

  - ### getMeteorologicalConditions

    public InternationalString getMeteorologicalConditions()
    Returns the meteorological conditions in the photo flight area, in particular clouds, snow and wind.
    Specified by:
      `getMeteorologicalConditions` in interface `EnvironmentalRecord`
    Returns:
      meteorological conditions in the photo flight area, or `null`.

  - ### setMeteorologicalConditions

    public void setMeteorologicalConditions(InternationalString newValue)
    Sets the meteorological conditions in the photo flight area, in particular clouds, snow and wind.
    Parameters:
      `newValue` - the meteorological conditions value.